#include <iostream>
#include <stdlib.h>
#include <time.h>

using namespace std;

const int cantBateriaPreguntas = 5;

int tiempo = 0;
int nivel = 2; //el nivel de dificultad es de 0 a 5;
enum operacion{suma=0,resta=1,multiplicacion=2,division=3,elevado=4};
time_t tInicio;


int estableceTiempo()
{
	string input;
	while (tiempo == 0)
	{
		cout << "Inserte el tiempo deseado (en segundos): ";

		getline(cin, input);

		if (atoi(input.c_str()))
		{
			tiempo = atoi(input.c_str());
		}
	}

}

string getOperador(int op)
{
	if (op == suma)
		return "+";
	else if (op == resta)
		return "-";
	else if (op == multiplicacion)
		return "*";
	else if (op == division)
		return "/";
	else
		return "^";
}

int pregunta(int a,int b,int c)
{
	int r = 0;

	string op = getOperador(c);
	string input;

	cout << a <<" " << op <<" " << b << " = ";

	getline(cin, input);

	if (atoi(input.c_str()))
	{
		r = atoi(input.c_str());
	}

	return r;

}

bool preguntasNivel(int nivel)
{
	bool correcto = false;

	int a;
	int b;
	int op;
	int r;

	switch (nivel)
	{
		case 0:
			a = rand() % 6;
			b = rand() % 6;
			op = rand() % 2;
			if (a > b)
				r = pregunta(a,b,op);
			else
				r = pregunta(b,a,op);

			if (op == suma)
			{
				if ((a + b) == r)
					correcto = true;
			}
			else
			{
				if (a > b)
				{
					if ((a - b) == r)
						correcto = true;
				}
				else
					if ((b - a) == r)
						correcto = true;
			}
			break;
		case 1:
			a = rand() % 11;
			b = rand() % 11;
			op = rand() % 2;

			if (a > b)
				r = pregunta(a,b,op);
			else
				r = pregunta(b,a,op);

			if (op == suma)
			{
				if ((a + b) == r)
					correcto = true;
			}
			else
			{
				if (a > b)
				{
					if ((a - b) == r)
						correcto = true;
				}
				else
					if ((b - a) == r)
						correcto = true;
			}
			break;
		case 2:
			a = rand() % 11;
			b = rand() % 11;
			op = rand() % 3;

			if (a > b)
				r = pregunta(a,b,op);
			else
				r = pregunta(b,a,op);

			if (op == suma)
			{
				if ((a + b) == r)
					correcto = true;
			}
			else if (op == resta)
			{
				if (a > b)
				{
					if ((a - b) == r)
						correcto = true;
				}
				else
					if ((b - a) == r)
						correcto = true;
			}
			else if (op == multiplicacion)
			{
				if ((a * b) == r)
					correcto = true;
			}
			break;
		case 3:
			a = (rand() % 10)+1;
			b = (rand() % 10)+1;
			op = rand() % 4;

			if (a > b)
				r = pregunta(a,b,op);
			else
				r = pregunta(b,a,op);

			if (op == suma)
			{
				if ((a + b) == r)
					correcto = true;
			}
			else if (op == resta)
			{
				if (a > b)
				{
					if ((a - b) == r)
						correcto = true;
				}
				else
					if ((b - a) == r)
						correcto = true;
			}
			else if (op == multiplicacion)
			{
				if ((a * b) == r)
					correcto = true;
			}
			else if (op == division)
			{
				if (a > b)
				{
					if ((a / b) == r)
						correcto = true;
				}
				else
					if ((b / a) == r)
						correcto = true;
			}
			break;
		case 4:
			a = (rand() % 10) + 1;
			b = (rand() % 10) + 1;
			op = rand() % 4;

			r = pregunta(a,b,op);

			if (op == suma)
			{
				if ((a + b) == r)
					correcto = true;
			}
			else if (op == resta)
			{
				if ((a - b) == r)
					correcto = true;
			}
			else if (op == multiplicacion)
			{
				if ((a * b) == r)
					correcto = true;
			}
			else if (op == division)
			{
				if ((a / b) == r)
					correcto = true;
			}
			break;
		case 5:
			a = (rand() % 20) + 1;
			b = (rand() % 20) + 1;
			op = rand() % 5;

			r = pregunta(a,b,op);

			if (op == suma)
			{
				if ((a + b) == r)
					correcto = true;
			}
			else if (op == resta)
			{
				if ((a - b) == r)
					correcto = true;
			}
			else if (op == multiplicacion)
			{
				if ((a * b) == r)
					correcto = true;
			}
			else if (op == division)
			{
				if ((a / b) == r)
					correcto = true;
			}
			else if (op == elevado)
			{
				if ((a ^ b) == r)
					correcto = true;
			}
			break;

	}
	return correcto;
}

int bateriaPreguntas() //devuelve la cantidad de preguntas acertadas
{
	int cant = cantBateriaPreguntas;
	int acertadas = 0;
	while ((cant > 0) && (difftime(time(0),tInicio) < tiempo))
	{
		if (preguntasNivel(nivel))
		{
			acertadas++;
			cout << "Correcto." << "\n";

		}
		else
			cout << "No es correcto." << "\n";
		cant--;
	}
	return acertadas;


}

float calculaPuntuacion(int acertadas)
{
	//maxima puntuacion por bateria es 100.
	float punt = (100 / cantBateriaPreguntas);
	punt = punt * acertadas;
	//penalizacion por nivel 1/6 en el nivel más bajo, y nada en el nivel más alto.
	if (punt > 0)
		punt = punt / (6 - nivel);

	//penalizacion por segundos.

	return punt;

}

int main()
{

	estableceTiempo();
	tInicio = time(0);
	int acertadas = 0;
	float puntuacion = 0;


	while (difftime(time(0),tInicio) < tiempo)
	{

		acertadas = bateriaPreguntas();
		if (acertadas > (cantBateriaPreguntas / 2))
		{
			if (tiempo - difftime(time(0),tInicio) > 0)
			{
				cout << "Muy bien. Sube Nivel!" << "\n";
				nivel++;
				cout << "Tiempo restante: " << tiempo - difftime(time(0),tInicio) << "\n";
			}
		}
		else
		{
			if (tiempo - difftime(time(0),tInicio) > 0)
			{
			cout << "Mal. Baja Nivel!" << "\n";
			nivel--;
			cout << "Tiempo restante: " << tiempo - difftime(time(0),tInicio) << "\n";
			}
		}
		puntuacion = puntuacion + calculaPuntuacion(acertadas);
	}

	//penalizacion de tiempo inicial.

	puntuacion = (puntuacion / tiempo) * 10;

	cout << "\n";
	cout << "Puntuacion final: " << puntuacion << " para " << tiempo << " segundos." "\n";

    return 0;

}
